#!/bin/bash

if [ $# -lt 2 ]
then
  echo "Usage $0 <inputfilename> <output-filename>"
  exit -1
fi

pcInputFilename=$1
pcOutputFilename=$2
iResult=0
LastModified=$(stat -c %Y $pcOutputFilename)

while [ "$iResult" -eq "0" ]
do
   TimeModified=$(stat -c %Y $pcOutputFilename) 
   if [ "$TimeModified" -gt "$LastModified" ]
   then
     DiffString=$(diff $pcInputFilename $pcOutputFilename)
     if [ -n "$DiffString" ]
     then
        echo "Difference in files :-( "
        echo "Logging difference to file diff.txt"
	echo $DiffString > diff.txt
	iResult=-1;
     fi
     LastModified=$TimeModified
   fi
   if [ "$iResult" -eq "0" ]
   then 
     usleep 200000
   fi
done
