/*
 * SettingsDialog.java
 *
 * Created on 15 september 2005, 12:41
 */

package gui;

/**
 *
 * @author  Arthur Coolen
 */
public class SettingsDialog extends javax.swing.JDialog {
    
    /**
     * Creates new form SettingsDialog 
     */
    public SettingsDialog() {
        initComponents();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        RMIServerNameLabel = new javax.swing.JLabel();
        RMIServerNameText = new javax.swing.JTextField(otbgui.RMIServerName);
        RMIServerPortLabel = new javax.swing.JLabel();
        RMIServerPortText = new javax.swing.JTextField(otbgui.RMIServerPort);
        RMIRegistryNameLabel = new javax.swing.JLabel();
        RMIRegistryNameText = new javax.swing.JTextField(otbgui.RMIRegistryName);
        OTDBUserNameLabel = new javax.swing.JLabel();
        OTDBUserNameText = new javax.swing.JTextField(otbgui.OTDBUserName);
        OTDBPasswordLabel = new javax.swing.JLabel();
        OTDBPasswordText = new javax.swing.JPasswordField(otbgui.OTDBPassword);

        OTDBDBNameLabel = new javax.swing.JLabel();
        OTDBDBNameText = new javax.swing.JTextField(otbgui.OTDBDBName);
        SettingsDialogOkButton = new javax.swing.JButton();
        SettingsDialogCancelButton = new javax.swing.JButton();
        SettingsDialogApplyButton = new javax.swing.JButton();

        getContentPane().setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        RMIServerNameLabel.setText("RMI Server Name");
        getContentPane().add(RMIServerNameLabel, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 20, -1, -1));

        RMIServerNameText.setToolTipText("give host(name or ip) where to find the RMI server");
        getContentPane().add(RMIServerNameText, new org.netbeans.lib.awtextra.AbsoluteConstraints(140, 20, 190, 20));

        RMIServerPortLabel.setText("RMI Server Port");
        RMIServerPortLabel.setToolTipText("");
        getContentPane().add(RMIServerPortLabel, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 45, -1, -1));

        RMIServerPortText.setToolTipText("Port on RMI Server to use");
        getContentPane().add(RMIServerPortText, new org.netbeans.lib.awtextra.AbsoluteConstraints(140, 45, 60, -1));

        RMIRegistryNameLabel.setText("RMI Registry Name");
        getContentPane().add(RMIRegistryNameLabel, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 70, -1, -1));

        RMIRegistryNameText.setToolTipText("Name used in Registry on Server for this port");
        getContentPane().add(RMIRegistryNameText, new org.netbeans.lib.awtextra.AbsoluteConstraints(140, 70, 190, -1));

        OTDBUserNameLabel.setText("OTDB UserName");
        getContentPane().add(OTDBUserNameLabel, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 95, -1, -1));

        OTDBUserNameText.setToolTipText("UserName for OTDB Database");
        OTDBUserNameText.setEnabled(false);
        getContentPane().add(OTDBUserNameText, new org.netbeans.lib.awtextra.AbsoluteConstraints(140, 95, 190, -1));

        OTDBPasswordLabel.setText("OTDB Password");
        getContentPane().add(OTDBPasswordLabel, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 120, -1, -1));

        OTDBPasswordText.setFont(new java.awt.Font("Tahoma", 0, 11));
        OTDBPasswordText.setToolTipText("OTDB Database Password");
        OTDBPasswordText.setEnabled(false);
        getContentPane().add(OTDBPasswordText, new org.netbeans.lib.awtextra.AbsoluteConstraints(140, 120, 190, -1));

        OTDBDBNameLabel.setText("OTDB DBName");
        getContentPane().add(OTDBDBNameLabel, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 145, -1, -1));

        OTDBDBNameText.setToolTipText("OTDB Database Name");
        OTDBDBNameText.setEnabled(false);
        getContentPane().add(OTDBDBNameText, new org.netbeans.lib.awtextra.AbsoluteConstraints(140, 145, 190, -1));

        SettingsDialogOkButton.setText("Ok");
        SettingsDialogOkButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                SettingsDialogOkButtonActionPerformed(evt);
            }
        });

        getContentPane().add(SettingsDialogOkButton, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 200, -1, -1));

        SettingsDialogCancelButton.setText("Cancel");
        SettingsDialogCancelButton.setToolTipText("Reset to Default and quit dialog");
        SettingsDialogCancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                SettingsDialogCancelButtonActionPerformed(evt);
            }
        });

        getContentPane().add(SettingsDialogCancelButton, new org.netbeans.lib.awtextra.AbsoluteConstraints(70, 200, -1, -1));

        SettingsDialogApplyButton.setText("Apply");
        SettingsDialogApplyButton.setToolTipText("Apply the filled in values");
        SettingsDialogApplyButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                SettingsDialogApplyButtonActionPerformed(evt);
            }
        });

        getContentPane().add(SettingsDialogApplyButton, new org.netbeans.lib.awtextra.AbsoluteConstraints(140, 200, -1, -1));

    }
    // </editor-fold>//GEN-END:initComponents

    private void SettingsDialogApplyButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_SettingsDialogApplyButtonActionPerformed
        otbgui.RMIServerName  = RMIServerNameText.getText();      
        otbgui.RMIServerPort  = RMIServerPortText.getText();
        otbgui.RMIRegistryName= RMIRegistryNameText.getText();
        otbgui.OTDBUserName   = OTDBUserNameText.getText();
        char[] duh = OTDBPasswordText.getPassword();
        String aS = new String(duh);
        otbgui.OTDBPassword= aS;
        otbgui.OTDBDBName     = OTDBDBNameText.getText(); 
    }//GEN-LAST:event_SettingsDialogApplyButtonActionPerformed

    private void SettingsDialogCancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_SettingsDialogCancelButtonActionPerformed
        RMIServerNameText.setText(otbgui.RMIServerName);
        RMIServerPortText.setText(otbgui.RMIServerPort);
        RMIRegistryNameText.setText(otbgui.RMIRegistryName);
        OTDBUserNameText.setText(otbgui.OTDBUserName);
        OTDBPasswordText.setText(otbgui.OTDBPassword);
        OTDBDBNameText.setText(otbgui.OTDBDBName);
    }//GEN-LAST:event_SettingsDialogCancelButtonActionPerformed

    private void SettingsDialogOkButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_SettingsDialogOkButtonActionPerformed
        otbgui.RMIServerName  = RMIServerNameText.getText();
        otbgui.RMIServerPort  = RMIServerPortText.getText();
        otbgui.RMIRegistryName= RMIRegistryNameText.getText();
        otbgui.OTDBUserName   = OTDBUserNameText.getText();
        char[] duh = OTDBPasswordText.getPassword();
        String aS = new String(duh);
        otbgui.OTDBPassword   = aS;
        otbgui.OTDBDBName     = OTDBDBNameText.getText();
        this.dispose();
    }//GEN-LAST:event_SettingsDialogOkButtonActionPerformed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel OTDBDBNameLabel;
    private javax.swing.JTextField OTDBDBNameText;
    private javax.swing.JLabel OTDBPasswordLabel;
    private javax.swing.JPasswordField OTDBPasswordText;
    private javax.swing.JLabel OTDBUserNameLabel;
    private javax.swing.JTextField OTDBUserNameText;
    private javax.swing.JLabel RMIRegistryNameLabel;
    private javax.swing.JTextField RMIRegistryNameText;
    private javax.swing.JLabel RMIServerNameLabel;
    private javax.swing.JTextField RMIServerNameText;
    private javax.swing.JLabel RMIServerPortLabel;
    private javax.swing.JTextField RMIServerPortText;
    private javax.swing.JButton SettingsDialogApplyButton;
    private javax.swing.JButton SettingsDialogCancelButton;
    private javax.swing.JButton SettingsDialogOkButton;
    // End of variables declaration//GEN-END:variables
    
}
